jjb: lttng-tools: Add gerrit job
[lttng-ci.git] / scripts / lttng-modules / param-build.sh
CommitLineData
5a196804 1#!/bin/bash -exu
f3d8604b 2#
1d5a0a3c 3# Copyright (C) 2016-2019 - Michael Jeanson <mjeanson@efficios.com>
f3d8604b
MJ
4#
5# This program is free software: you can redistribute it and/or modify
6# it under the terms of the GNU General Public License as published by
7# the Free Software Foundation, either version 3 of the License, or
8# (at your option) any later version.
9#
10# This program is distributed in the hope that it will be useful,
11# but WITHOUT ANY WARRANTY; without even the implied warranty of
12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13# GNU General Public License for more details.
14#
15# You should have received a copy of the GNU General Public License
16# along with this program. If not, see <http://www.gnu.org/licenses/>.
17
39961776
MJ
18# Parameters
19arch=${arch:-}
20cross_arch=${cross_arch:-}
21ktag=${ktag:-}
5a196804
MJ
22kgitrepo=${kgitrepo:-}
23mversion=${mversion:-}
24mgitrepo=${mgitrepo:-}
39961776
MJ
25
26
339db64d
MJ
27## FUNCTIONS ##
28
f3d8604b
MJ
29# Kernel version compare functions
30verlte() {
51fa2ab3 31 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | head -n1)" ]
f3d8604b
MJ
32}
33
34verlt() {
51fa2ab3 35 [ "$1" = "$2" ] && return 1 || verlte "$1" "$2"
f3d8604b
MJ
36}
37
38vergte() {
51fa2ab3 39 [ "$1" = "$(printf '%s\n%s' "$1" "$2" | sort -V | tail -n1)" ]
f3d8604b
MJ
40}
41
42vergt() {
51fa2ab3 43 [ "$1" = "$2" ] && return 1 || vergte "$1" "$2"
f3d8604b
MJ
44}
45
339db64d 46
5a196804
MJ
47git_clone_modules_sources() {
48 mkdir -p "$MODULES_GIT_DIR"
49 git clone --depth=1 -b "${mversion}" "${mgitrepo}" "$MODULES_GIT_DIR"
50}
51
52# Checkout a shallow kernel tree of the specified tag
53git_clone_linux_sources() {
54 mkdir -p "$LINUX_GIT_DIR"
55 git clone --depth=1 -b "${ktag}" --reference "$LINUX_GIT_REF_REPO_DIR" "${kgitrepo}" "$LINUX_GIT_DIR"
56}
7e02032c 57
7e02032c 58
5a196804
MJ
59# Export the kernel sources from the git repo
60git_export_linux_sources() {
61 cd "$LINUX_GIT_DIR"
62 git archive "${ktag}" | tar -x -C "$LINUX_SRCOBJ_DIR"
63}
64
65
66# Upload the tar archive to the object store
67upload_archive_obj() {
68 s3cmd -c "$WORKSPACE/.s3cfg" put "$WORKSPACE/$obj_name" "$obj_url_prefix/"
69 rm -f "$WORKSPACE/$obj_name"
70}
71
72
73extract_archive_obj() {
74 tar -xf "$WORKSPACE/$obj_name" -C "$LINUX_OBJ_DIR"
75 rm -f "$WORKSPACE/$obj_name"
76}
77
78
79tar_archive_obj() {
80 cd "$LINUX_OBJ_DIR"
81 tar -cf "$WORKSPACE/$obj_name" -I pbzip2 .
82 cd -
83}
84
85# Find the most recent GCC version supported by the kernel sources
86select_compiler() {
87 local selected_cc
88
89 cd "$LINUX_SRCOBJ_DIR"
90
91 kversion=$(make -s kernelversion)
92
93 set +e
94
1d5a0a3c 95 for cc in gcc-5 gcc-4.8; do
5a196804
MJ
96 if "${CROSS_COMPILE:-}${cc}" -I include/ -D__LINUX_COMPILER_H -D__LINUX_COMPILER_TYPES_H -E include/linux/compiler-gcc.h; then
97 selected_cc="$cc"
98 break
99 fi
100 done
101
102 set -e
103
104 if [ "x$selected_cc" = "x" ]; then
105 echo "Found no suitable compiler."
106 exit 1
107 fi
108
1d5a0a3c
MJ
109 # Force gcc-4.8 for kernels before 3.18
110 if { verlt "$kversion" "3.18"; }; then
23db2292 111 selected_cc=gcc-4.8
7e02032c
MJ
112 fi
113
425e4992
MJ
114 if [ "$selected_cc" != "gcc-4.8" ]; then
115 # Older kernel Makefiles do not expect the compiler to default to PIE
116 KAFLAGS="-fno-pie"
c45b04df 117 KCFLAGS="-fno-pie -no-pie -fno-stack-protector"
425e4992
MJ
118 KCPPFLAGS="-fno-pie"
119 export KAFLAGS KCFLAGS KCPPFLAGS
120 fi
121
5a196804 122 export CC="${CROSS_COMPILE:-}${selected_cc}"
1d5a0a3c 123 export HOSTCC="${selected_cc}"
5a196804
MJ
124
125 cd -
126}
127
128
129build_linux_kernel() {
130 cd "$LINUX_SRCOBJ_DIR"
131
132 kversion=$(make -s kernelversion)
133
7e02032c 134 # Generate kernel configuration
a1ae361e 135 case "$ktag" in
7e02032c 136 Ubuntu*)
39961776 137 if [ "${cross_arch}" = "powerpc" ]; then
5a196804 138 if vergte "${kversion}" "4.10"; then
39961776
MJ
139 echo "Ubuntu removed big endian powerpc configuration from kernel >= 4.10. Don't try to build it."
140 exit 0
141 fi
142 fi
a46abb0a
MJ
143 fakeroot debian/rules clean KW_DEFCONFIG_DIR=.
144 fakeroot debian/rules genconfigs KW_DEFCONFIG_DIR=.
5a196804 145 cp CONFIGS/"${ubuntu_config}" .config
7e02032c 146 ;;
c45b04df 147
7e02032c 148 *)
16844a6d
MJ
149 # Force 32bit build on i386, default is 64bit
150 if [ "$arch" = "i386" ]; then
5a196804
MJ
151 export ARCH="i386"
152 fi
153
154 # allyesconfig is mostly broken for kernels of the 2.6 series
155 if verlt "$kversion" "3.0"; then
156 vanilla_config="defconfig"
7a76a4d0
MJ
157 fi
158
5a196804 159 make "${vanilla_config}"
7e02032c
MJ
160 ;;
161 esac
162
53b51a15 163 # oldnoconfig was renamed in 4.19
5a196804 164 if vergte "$kversion" "4.19"; then
53b51a15 165 update_conf_target="olddefconfig"
5a196804 166 else
53b51a15 167 update_conf_target="oldnoconfig"
5a196804
MJ
168 fi
169
170 # Fix 'defined(@array)' was removed from recent perl
171 if [ -f "kernel/timeconst.pl" ]; then
172 sed -i 's/defined(\@\(.*\))/@\1/' kernel/timeconst.pl
173 fi
174
175 # Fix syntax of inline assembly which is confused with C++11 raw strings on gcc >= 5
53b51a15 176 if [ "$HOSTCC" != "gcc-4.8" ]; then
5a196804
MJ
177 if [ -f "arch/x86/kvm/svm.c" ]; then
178 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/svm.c
179 fi
180
181 if [ -f "arch/x86/kvm/vmx.c" ]; then
182 sed -i 's/ R"/ R "/g; s/"R"/" R "/g' arch/x86/kvm/vmx.c
183 fi
184 fi
185
53b51a15
MJ
186 # Newer binutils don't accept 3 operand 'cmp' instructions on ppc64
187 # Convert them to 'cmpw' which was previously done silently
188 if verlt "$kversion" "4.9"; then
189 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmp\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmpw\2/"
190 find arch/powerpc/ -name "*.S" -print0 | xargs -0 sed -i "s/\(cmpli\)\(\s\+[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+,\s*[a-zA-Z0-9]\+\)/cmplwi\2/"
191 sed -i "s/\$pie \-o \"\$ofile\"/\$pie --no-dynamic-linker -o \"\$ofile\"/" arch/powerpc/boot/wrapper
192 fi
193
5a196804
MJ
194 # Fix a typo in v2.6.36.x
195 if [ -f "arch/x86/kernel/entry_64.S" ]; then
196 sed -i 's/END(do_hypervisor_callback)/END(xen_do_hypervisor_callback)/' arch/x86/kernel/entry_64.S
197 fi
198
53b51a15
MJ
199 # Fix compiler switch in vdso Makefile for 2.6.36 to 2.6.36.2
200 if { vergte "$kversion" "2.6.36" && verlte "$kversion" "2.6.36.3"; }; then
201 sed -i 's/-m elf_x86_64/-m64/' arch/x86/vdso/Makefile
202 sed -i 's/-m elf_i386/-m32/' arch/x86/vdso/Makefile
203 fi
204
5a196804
MJ
205 # Fix kernel < 3.0 with gcc >= 4.7
206 if verlt "$kversion" "3.0"; then
207 sed -i '/linux\/compiler.h/a #include <linux\/linkage.h> \/* For asmregparm *\/' arch/x86/include/asm/ptrace.h
208 sed -i 's/extern long syscall_trace_enter/extern asmregparm long syscall_trace_enter/' arch/x86/include/asm/ptrace.h
209 sed -i 's/extern void syscall_trace_leave/extern asmregparm void syscall_trace_leave/' arch/x86/include/asm/ptrace.h
210 echo "header-y += linkage.h" >> include/linux/Kbuild
211 fi
212
7e02032c 213 # GCC 4.8
53b51a15
MJ
214 if [ "$HOSTCC" == "gcc-4.8" ]; then
215 scripts/config --disable CONFIG_CC_STACKPROTECTOR_STRONG
216 fi
7e02032c
MJ
217
218 # Don't try to sign modules
53b51a15 219 scripts/config --disable CONFIG_MODULE_SIG
7e02032c 220
9ef18fa2 221 # Disable kernel stack frame correctness validation, introduced in 4.6.0 and currently fails
53b51a15 222 scripts/config --disable CONFIG_STACK_VALIDATION
5a196804
MJ
223
224 # Cause problems with inline assembly on i386
53b51a15 225 scripts/config --disable CONFIG_DEBUG_SECTION_MISMATCH
5a196804 226
1d5a0a3c 227 # Don't build samples, they are broken on some kernel releases
53b51a15
MJ
228 scripts/config --disable CONFIG_SAMPLES
229 scripts/config --disable CONFIG_BUILD_DOCSRC
c45b04df
MJ
230
231 # Disable kcov
53b51a15 232 scripts/config --disable CONFIG_KCOV
c45b04df
MJ
233
234 # Broken on some RT kernels
53b51a15 235 scripts/config --disable CONFIG_HYPERV
1d5a0a3c 236
1e300ea9 237 # Broken drivers
53b51a15
MJ
238 scripts/config --disable CONFIG_RAPIDIO_TSI721
239 scripts/config --disable CONFIG_SGI_XP
240 scripts/config --disable CONFIG_MFD_WM8994
241 scripts/config --disable CONFIG_DRM_RADEON
242 scripts/config --disable CONFIG_SND_SOC_WM5100
1e300ea9 243
5a196804
MJ
244 # IGBVF won't build with recent gcc on 2.6.38.x
245 if { vergte "$kversion" "2.6.37" && verlt "$kversion" "2.6.38"; }; then
53b51a15 246 scripts/config --disable CONFIG_IGBVF
5a196804 247 fi
9ef18fa2 248
51fa2ab3 249 # Set required options
53b51a15
MJ
250 scripts/config --enable CONFIG_TRACEPOINTS
251 scripts/config --enable CONFIG_KALLSYMS
252 scripts/config --enable CONFIG_HIGH_RES_TIMERS
253 scripts/config --enable CONFIG_KPROBES
254 scripts/config --enable CONFIG_FTRACE
255 scripts/config --enable CONFIG_BLK_DEV_IO_TRACE
256 scripts/config --enable CONFIG_KALLSYMS_ALL
257 scripts/config --enable CONFIG_HAVE_SYSCALL_TRACEPOINTS
258 scripts/config --enable CONFIG_PERF_EVENTS
259 scripts/config --enable CONFIG_EVENT_TRACING
260 scripts/config --enable CONFIG_KRETPROBES
7e02032c 261
7a76a4d0 262 # Debug
5a196804
MJ
263 #cat .config
264
265 make "$update_conf_target" CC="$CC"
266 make -j"$NPROC" CC="$CC"
267
c45b04df 268 krelease=$(make -s kernelrelease CC="$CC")
5a196804
MJ
269
270 # Save the kernel and modules
271 mkdir -p "$LINUX_INSTOBJ_DIR/boot"
53b51a15
MJ
272 make INSTALL_MOD_PATH="$LINUX_INSTOBJ_DIR" INSTALL_MOD_STRIP=1 modules_install CC="$CC"
273 make INSTALL_PATH="$LINUX_INSTOBJ_DIR/boot" install CC="$CC"
5a196804
MJ
274 rm -f "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source" "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/build"
275 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
276 ln -s ../../../../sources "$LINUX_INSTOBJ_DIR/lib/modules/${krelease}/source"
277}
278
279
280extract_distro_headers() {
281
282 # Enter linux source dir
283 cd "${LINUX_SRCOBJ_DIR}"
284
285
286 # For RT kernels, copy version file
287 if [ -s localversion-rt ]; then
288 cp -a localversion-rt "${LINUX_HDROBJ_DIR}"
289 fi
290
291 # Copy all Makefile related stuff
292 find . -path './include/*' -prune \
293 -o -path './scripts/*' -prune -o -type f \
294 \( -name 'Makefile*' -o -name 'Kconfig*' -o -name 'Kbuild*' -o \
295 -name '*.sh' -o -name '*.pl' -o -name '*.lds' \) \
296 -print | cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
297
298 # Copy base scripts and include dirs
299 cp -a scripts include "${LINUX_HDROBJ_DIR}"
7e02032c 300
5a196804
MJ
301 # Copy arch includes
302 (find arch -name include -type d -print0 | \
303 xargs -0 -n1 -i: find : -type f) | \
304 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
305
306 # Copy arch scripts
307 (find arch -name scripts -type d -print0 | \
308 xargs -0 -n1 -i: find : -type f) | \
309 cpio -pd --preserve-modification-time "${LINUX_HDROBJ_DIR}"
310
311 # Cleanup scripts
312 rm -f "${LINUX_HDROBJ_DIR}/scripts/*.o"
313 rm -f "${LINUX_HDROBJ_DIR}/scripts/*/*.o"
314
04873cc3 315 # On powerpc 32bits this object is required to link modules
5a196804 316 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
317 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
318 :
319 else
04873cc3
MJ
320 cp -a --parents arch/powerpc/lib/crtsavres.[So] "${LINUX_HDROBJ_DIR}/"
321 fi
5a196804
MJ
322 fi
323
324 # On arm64 between 4.13 and 1.15 this object is required to build with ftrace support
325 if [ "${karch}" = "arm64" ]; then
326 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
327 cp -a --parents arch/arm64/kernel/ftrace-mod.[So] "${LINUX_HDROBJ_DIR}/"
328 fi
329 fi
330
331 # Newer kernels need objtool to build modules when CONFIG_STACK_VALIDATION=y
332 if [ -f tools/objtool/objtool ]; then
333 cp -a --parents tools/objtool/objtool "${LINUX_HDROBJ_DIR}/"
334 fi
335
336 if [ -f "arch/x86/kernel/macros.s" ]; then
337 cp -a --parents arch/x86/kernel/macros.s "${LINUX_HDROBJ_DIR}/"
338 fi
339
340 # Copy modules related stuff, if available
341 if [ -s Module.symvers ]; then
342 cp Module.symvers "${LINUX_HDROBJ_DIR}"
343 fi
344
345 if [ -s System.map ]; then
346 cp System.map "${LINUX_HDROBJ_DIR}"
347 fi
348
349 if [ -s Module.markers ]; then
350 cp Module.markers "${LINUX_HDROBJ_DIR}"
351 fi
352
353 # Copy config file
354 cp .config "${LINUX_HDROBJ_DIR}"
355
356 # Make sure the Makefile and version.h have a matching timestamp so that
357 # external modules can be built
358 if [ -s "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h" ]; then
359 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/generated/uapi/linux/version.h"
360 elif [ -s "${LINUX_HDROBJ_DIR}/include/linux/version.h" ]; then
361 touch -r "${LINUX_HDROBJ_DIR}/Makefile" "${LINUX_HDROBJ_DIR}/include/linux/version.h"
362 else
363 echo "Missing version.h"
364 exit 1
365 fi
366 touch -r "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/generated/autoconf.h"
367
368 # Copy .config to include/config/auto.conf so "make prepare" is unnecessary.
369 cp "${LINUX_HDROBJ_DIR}/.config" "${LINUX_HDROBJ_DIR}/include/config/auto.conf"
370
371 # Finally clean the object files from the full source tree
372 make clean
373
374 # And regen the modules support files
375 make modules_prepare CC="$CC"
51fa2ab3 376
04873cc3 377 # On powerpc 32bits this object is required to link modules
d815b018 378 if [ "${karch}" = "powerpc" ]; then
10528202
MJ
379 if [ "x$(scripts/config -s CONFIG_PPC64)" = "xy" ] && vergte "${kversion}" "5.4"; then
380 :
381 else
04873cc3
MJ
382 make arch/powerpc/lib/crtsavres.o CC="$CC"
383 fi
d815b018
MJ
384 fi
385
7a76a4d0 386 # On arm64 between 4.13 and 4.15 this object is required to build with ftrace support
a1ae361e 387 if [ "${karch}" = "arm64" ]; then
c236528e 388 if [ -f "arch/arm64/kernel/ftrace-mod.S" ]; then
5a196804 389 make arch/arm64/kernel/ftrace-mod.o CC="$CC"
a1ae361e
MJ
390 fi
391 fi
392
7e02032c 393 # Version specific tasks
a1ae361e 394 case "$ktag" in
7e02032c
MJ
395 Ubuntu*)
396 # Add Ubuntu ABI number to kernel headers, this is normally done by the packaging code
a1ae361e 397 ABINUM="$(echo "$ktag" | grep -P -o 'Ubuntu-(lts-)?.*-\K\d+(?=\..*)')"
5a196804
MJ
398 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> include/generated/utsrelease.h
399 echo "#define UTS_UBUNTU_RELEASE_ABI $ABINUM" >> "${LINUX_HDROBJ_DIR}/include/generated/utsrelease.h"
7e02032c
MJ
400 ;;
401 esac
7e02032c
MJ
402}
403
404
339db64d
MJ
405build_modules() {
406
5a196804
MJ
407 local kdir="$1"
408 local outdir="$2"
409 local kversion
410
411 kversion=$(make -C "$LINUX_HDROBJ_DIR" -s kernelversion)
339db64d 412
339db64d 413 # Enter lttng-modules source dir
5a196804 414 cd "${MODULES_GIT_DIR}"
339db64d
MJ
415
416 # kernels 3.10 to 3.10.13 and 3.11 to 3.11.2 introduce a deadlock in the
417 # timekeeping subsystem. We want those build to fail.
5a196804
MJ
418 if { vergte "$kversion" "3.10" && verlte "$kversion" "3.10.13"; } || \
419 { vergte "$kversion" "3.11" && verlte "$kversion" "3.11.2"; }; then
339db64d
MJ
420
421 set +e
422
423 # Build modules
51fa2ab3 424 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
0f71a764 425 ret=$?
339db64d 426
5a196804
MJ
427 set -e
428
339db64d 429 # We expect this build to fail, if it doesn't, fail the job.
0f71a764 430 if [ "$ret" -eq 0 ]; then
e9b44189 431 echo "This build should have failed."
339db64d
MJ
432 exit 1
433 fi
434
435 # We have to publish at least one file or the build will fail
5a196804 436 echo "This kernel is broken, there is a deadlock in the timekeeping subsystem." > "${outdir}/BROKEN.txt.ko"
339db64d 437
5a196804 438 KERNELDIR="${kdir}" make clean
7e02032c 439
339db64d
MJ
440 else # Regular build
441
442 # Build modules against full kernel sources
51fa2ab3 443 KERNELDIR="${kdir}" make -j"${NPROC}" V=1 CC="$CC"
339db64d
MJ
444
445 # Install modules to build dir
5a196804 446 KERNELDIR="${kdir}" make INSTALL_MOD_PATH="${outdir}" modules_install
339db64d
MJ
447
448 # Clean build dir
5a196804 449 KERNELDIR="${kdir}" make clean
339db64d
MJ
450 fi
451}
452
453
454## MAIN ##
455
f3d8604b
MJ
456# Use all CPU cores
457NPROC=$(nproc)
458
5a196804
MJ
459MODULES_GIT_DIR="${WORKSPACE}/src/lttng-modules"
460LINUX_GIT_DIR="${WORKSPACE}/src/linux"
339db64d 461
5a196804
MJ
462LINUX_OBJ_DIR="${WORKSPACE}/linux"
463LINUX_SRCOBJ_DIR="${LINUX_OBJ_DIR}/sources"
464LINUX_HDROBJ_DIR="${LINUX_OBJ_DIR}/headers"
465LINUX_INSTOBJ_DIR="${LINUX_OBJ_DIR}/install"
339db64d 466
5a196804
MJ
467MODULES_OUTPUT_KSRC_DIR="${WORKSPACE}/build/lttng-modules-ksrc"
468MODULES_OUTPUT_KHDR_DIR="${WORKSPACE}/build/lttng-modules-khdr"
339db64d 469
5a196804
MJ
470LINUX_GIT_REF_REPO_DIR="$HOME/gitcache/linux-stable.git/"
471
472OBJ_STORE_URL="s3://jenkins"
473
474cd "$WORKSPACE"
475
476# Create build directories
477mkdir -p "${LINUX_SRCOBJ_DIR}" "${LINUX_HDROBJ_DIR}" "${LINUX_INSTOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
478
479git_clone_modules_sources
339db64d 480
7e02032c 481# Setup cross compile env if available
39961776 482if [ "x${cross_arch}" != "x" ]; then
7e02032c
MJ
483
484 case "$cross_arch" in
485 "armhf")
486 karch="arm"
487 cross_compile="arm-linux-gnueabihf-"
53b51a15 488 vanilla_config="imx_v6_v7_defconfig"
7e02032c
MJ
489 ubuntu_config="armhf-config.flavour.generic"
490 ;;
491
492 "arm64")
493 karch="arm64"
494 cross_compile="aarch64-linux-gnu-"
53b51a15 495 vanilla_config="defconfig"
7e02032c
MJ
496 ubuntu_config="arm64-config.flavour.generic"
497 ;;
498
499 "powerpc")
500 karch="powerpc"
501 cross_compile="powerpc-linux-gnu-"
e9b44189 502 vanilla_config="ppc44x_defconfig"
7e02032c
MJ
503 ubuntu_config="powerpc-config.flavour.powerpc-smp"
504 ;;
505
506 "ppc64el")
507 karch="powerpc"
508 cross_compile="powerpc64le-linux-gnu-"
e9b44189 509 vanilla_config="pseries_le_defconfig"
7e02032c
MJ
510 ubuntu_config="ppc64el-config.flavour.generic"
511 ;;
512
513 *)
51fa2ab3 514 echo "Unsupported cross arch $cross_arch"
7e02032c
MJ
515 exit 1
516 ;;
517 esac
339db64d 518
7e02032c
MJ
519 # Export variables used by Kbuild for cross compilation
520 export ARCH="${karch}"
521 export CROSS_COMPILE="${cross_compile}"
339db64d 522
7e02032c 523# Set arch specific values if we are not cross compiling
39961776 524elif [ "x${arch}" != "x" ]; then
e9b44189 525
7e02032c 526 case "$arch" in
16844a6d 527 "i386")
7e02032c 528 karch="x86"
e9b44189 529 vanilla_config="allyesconfig"
7e02032c
MJ
530 ubuntu_config="i386-config.flavour.generic"
531 ;;
532
16844a6d 533 "amd64")
7e02032c 534 karch="x86"
e9b44189 535 vanilla_config="allyesconfig"
7e02032c
MJ
536 ubuntu_config="amd64-config.flavour.generic"
537 ;;
538
539 "armhf")
540 karch="arm"
e9b44189 541 vanilla_config="allyesconfig"
7e02032c
MJ
542 ubuntu_config="armhf-config.flavour.generic"
543 ;;
544
545 "arm64")
546 karch="arm64"
e9b44189 547 vanilla_config="allyesconfig"
7e02032c
MJ
548 ubuntu_config="arm64-config.flavour.generic"
549 ;;
550
551 "powerpc")
552 karch="powerpc"
e9b44189 553 vanilla_config="allyesconfig"
7e02032c
MJ
554 ubuntu_config="powerpc-config.flavour.powerpc-smp"
555 ;;
556
557 "ppc64el")
558 karch="powerpc"
e9b44189 559 vanilla_config="allyesconfig"
7e02032c
MJ
560 ubuntu_config="ppc64el-config.flavour.generic"
561 ;;
562
563 *)
564 echo "Unsupported arch $arch"
565 exit 1
566 ;;
567 esac
568else
04873cc3 569 echo "No arch or cross_arch specified"
7e02032c
MJ
570 exit 1
571fi
339db64d 572
339db64d 573
b214d997 574
5a196804
MJ
575# First get the kernel build from the object store, or build it, if it's
576# not available.
339db64d 577
5a196804
MJ
578echo "# Setup endpoint
579host_base = obj.internal.efficios.com
580host_bucket = obj.internal.efficios.com
581bucket_location = us-east-1
582use_https = True
7e02032c 583
5a196804
MJ
584# Setup access keys
585access_key = jenkins
586secret_key = echo123456
339db64d 587
5a196804
MJ
588# Enable S3 v4 signature APIs
589signature_v2 = False" > "$WORKSPACE/.s3cfg"
339db64d 590
c45b04df 591url_hash="$(echo -n "$kgitrepo" | md5sum | awk '{ print $1 }')"
5a196804 592obj_name="linux.tar.bz2"
c45b04df 593obj_url_prefix="$OBJ_STORE_URL/linux-build/$url_hash/$ktag/$arch/${cross_arch:-native}"
5a196804 594obj_url="$obj_url_prefix/$obj_name"
339db64d 595
5a196804
MJ
596set +e
597s3cmd -c "$WORKSPACE/.s3cfg" get "$obj_url"
598ret=$?
599set -e
339db64d 600
5a196804
MJ
601case "$ret" in
602 "0")
603 extract_archive_obj
604 ;;
a1ae361e 605
5a196804
MJ
606 "12")
607 echo "File not found"
339db64d 608
5a196804
MJ
609 # Build all the things and upload
610 # then finish the module build...
339db64d 611
5a196804
MJ
612 git_clone_linux_sources
613 git_export_linux_sources
339db64d 614
5a196804 615 select_compiler
a1ae361e 616
5a196804
MJ
617 ## PREPARE FULL LINUX SOURCE TREE
618 build_linux_kernel
d138fc44 619
5a196804
MJ
620 ## EXTRACT DISTRO STYLE KERNEL HEADERS / DEVEL
621 extract_distro_headers
339db64d 622
5a196804 623 tar_archive_obj
339db64d 624
5a196804 625 upload_archive_obj
339db64d 626
5a196804 627 ;;
339db64d 628
5a196804
MJ
629 *)
630 echo "Unknown error? Abort"
631 exit 1
632 ;;
633esac
339db64d 634
5a196804 635select_compiler
f3d8604b 636
7e02032c 637## BUILD modules
5a196804
MJ
638# Either we downloaded a pre-build kernel or we built it and uploaded
639# the archive for future builds.
640
641cd "$WORKSPACE"
f3d8604b 642
339db64d 643# Build modules against full kernel sources
5a196804 644build_modules "${LINUX_SRCOBJ_DIR}" "${MODULES_OUTPUT_KSRC_DIR}"
f3d8604b 645
339db64d 646# Build modules against kernel headers
5a196804 647build_modules "${LINUX_HDROBJ_DIR}" "${MODULES_OUTPUT_KHDR_DIR}"
f3d8604b 648
5a196804
MJ
649# Make sure some modules were actually built
650tree "${MODULES_OUTPUT_KSRC_DIR}"
651if [ "x$(find "${MODULES_OUTPUT_KSRC_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
652 echo "No modules built!"
653 exit 1
654fi
655
5a196804
MJ
656tree "${MODULES_OUTPUT_KHDR_DIR}"
657if [ "x$(find "${MODULES_OUTPUT_KHDR_DIR}" -name '*.ko*' -printf yes -quit)" != "xyes" ]; then
7e02032c
MJ
658 echo "No modules built!"
659 exit 1
660fi
b214d997 661
f3d8604b 662# EOF
This page took 0.056295 seconds and 4 git commands to generate.